<template>
    <div v-if="standings !== undefined && !Array.isArray(standings)">
        <div class="league-standings-types">
            <div
                v-for="(type, idx) in types"
                :key="idx"
                :class="['item', {'active': type.selected}]"
                @click.prevent="selectType(idx)"
            >
                {{ type.name }}
            </div>
        </div>

        <div class="league-standings-table">
            <div class="table-head">
                <div class="row">
                    <div class="cell cell-n">#</div>
                    <div class="cell cell-team">Team Name</div>
                    <div class="cell cell-p">P</div>
                    <div class="cell cell-w">W</div>
                    <div class="cell cell-d">D</div>
                    <div class="cell cell-l">L</div>
                    <div class="cell cell-goals">Goals</div>
                    <div class="cell cell-lastfive">Last 5</div>
                    <div class="cell cell-pts">Points</div>
                </div>
            </div>
            <div class="table-body">

                <div
                    v-for="(item, idx) in standings.team"
                    :key="idx"
                    :class="[
                        'row',
                        item.promo ? `row-promo-${item.promo}` : '',
                        {'highlighted-red': item.highlighted}
                    ]"
                >
                    <div class="cell cell-n"></div>
                    <div class="cell cell-team">
                        <div class="team-logo" :style="{
                            backgroundImage: logos[item['@id']] ? `url('/storage/${logos[item['@id']]}')` : `url('/img/team1.png')`
                        }"></div>
                        <div class="team-name">{{ item['@name'] }}</div>
                    </div>
                    <div class="cell cell-p">{{ item[selectedType]['@gp'] }}</div>
                    <div class="cell cell-w">{{ item[selectedType]['@w']}}</div>
                    <div class="cell cell-d">{{ item[selectedType]['@d'] }}</div>
                    <div class="cell cell-l">{{ item[selectedType]['@l'] }}</div>
                    <div class="cell cell-goals">{{ item[selectedType]['@gs'] }} : {{ item[selectedType]['@ga'] }}</div>
                    <div class="cell cell-lastfive">
                        <i
                            v-for="(n, nIdx) in item['@recent_form'].split('')"
                            :key="nIdx"
                            :class="{
                                'item': true,
                                'item-green': n === 'W',
                                'item-red': n === 'L',
                                'item-gray': n === 'D'
                            }"
                        ></i>
                        <span v-if="!item['@recent_form'].length">-</span>
                    </div>
                    <div class="cell cell-pts">{{ item.total['@p'] }}</div>
                </div>
            </div>
        </div>

        <div class="league-standings-legend">
            <div class="item item-championsleague">Promotion - Champions League (Group Stage)</div>
            <div class="item item-europaleague">Promotion - Europa League (Group Stage)</div>
            <div class="item item-championship">Relegation - Championship</div>
        </div>

        <div class="league-standings-hint">
            In the event that two (or more) teams have an equal number of points, the following rules break the tie:<br/>1. Number of victories 2. Goal difference 3. Goals scored
        </div>
    </div>
    <div v-else-if="standings !== undefined && standings.length && Array.isArray(standings)">
        <div class="league-standings-types">
            <div
                v-for="(type, idx) in types"
                :key="idx"
                :class="['item', {'active': type.selected}]"
                @click.prevent="selectType(idx)"
            >
                {{ type.name }}
            </div>
        </div>

        <div class="league-standings-table group" v-for="(group, groupIdx) in standings">
            <div class="table-head">
                <div class="row">
                    <div class="cell cell-team cell-team-groupname">{{ group['@group'] }}</div>
                </div>
                <div class="row">
                    <div class="cell cell-n">#</div>
                    <div class="cell cell-team">Team Name</div>
                    <div class="cell cell-p">P</div>
                    <div class="cell cell-w">W</div>
                    <div class="cell cell-d">D</div>
                    <div class="cell cell-l">L</div>
                    <div class="cell cell-goals">Goals</div>
                    <div class="cell cell-lastfive">Last 5</div>
                    <div class="cell cell-pts">Points</div>
                </div>
            </div>
            <div class="table-body">

                <div
                    v-for="(item, idx) in group.team"
                    :key="idx"
                    :class="[
                    'row',
                    item.promo ? `row-promo-${item.promo}` : '',
                    {'highlighted-red': item.highlighted}
                ]"
                >
                    <div class="cell cell-n"></div>
                    <div class="cell cell-team">
                        <div class="team-logo" :style="{
                        backgroundImage: logos[item['@id']] ? `url('/storage/${logos[item['@id']]}')` : `url('/img/team1.png')`
                    }"></div>
                        <div class="team-name">{{ item['@name'] }}</div>
                    </div>
                    <div class="cell cell-p">{{ item[selectedType]['@gp'] }}</div>
                    <div class="cell cell-w">{{ item[selectedType]['@w']}}</div>
                    <div class="cell cell-d">{{ item[selectedType]['@d'] }}</div>
                    <div class="cell cell-l">{{ item[selectedType]['@l'] }}</div>
                    <div class="cell cell-goals">{{ item[selectedType]['@gs'] }} : {{ item[selectedType]['@ga'] }}</div>
                    <div class="cell cell-lastfive">
                        <i
                            v-for="(n, nIdx) in item['@recent_form'].split('')"
                            :key="nIdx"
                            :class="{
                            'item': true,
                            'item-green': n === 'W',
                            'item-red': n === 'L',
                            'item-gray': n === 'D'
                        }"
                        ></i>
                        <span v-if="!item['@recent_form'].length">-</span>
                    </div>
                    <div class="cell cell-pts">{{ item.total['@p'] }}</div>
                </div>
            </div>
        </div>

        <div class="league-standings-legend">
            <div class="item item-championsleague">Promotion - Champions League (Group Stage)</div>
            <div class="item item-europaleague">Promotion - Europa League (Group Stage)</div>
            <div class="item item-championship">Relegation - Championship</div>
        </div>

        <div class="league-standings-hint">
            In the event that two (or more) teams have an equal number of points, the following rules break the tie:<br/>1. Number of victories 2. Goal difference 3. Goals scored
        </div>
    </div>
    <div class="no-standings" v-else>No standings found for this league</div>
</template>

<script>
import { Fragment } from 'vue-fragment'
export default {
    name: 'LeagueStandingsList',
    data: () => ({
        types: [
            { name: 'Overall', selected: true },
            { name: 'Home', selected: false },
            { name: 'Away', selected: false }
        ],
        selectedType: 'overall'
    }),
    props: {
        standings: {
            default: () => [],
            required: true
        },
        logos: {
            default: () => {}
        }
    },
    methods: {
        selectType(idx) {
            this.selectedType = this.types[idx].name.toLowerCase()
            this.types.forEach((type, index) => {
                type.selected = index === idx;
            })
        }
    },
    components: {
        Fragment,

    }
}
</script>

<style scoped>
    .no-standings {
        font-size: 18px;
        text-align: center;
        padding: 24px 12px;
    }

    .league-standings-table.group + .league-standings-table.group {
        margin-top: 48px;
    }

</style>
